﻿#region 命名空间

#endregion

namespace ContentFactory
{
    /// <summary>
    /// 枚举素材的状态。
    /// </summary>
    public enum ContentState
    {
        /// <summary>
        /// 未生成（或需要更新）。
        /// </summary>
        UnCreated = 0,
        /// <summary>
        /// 正在生成。
        /// </summary>
        Creating,
        /// <summary>
        /// 已生成（且更新为最新）。
        /// </summary>
        Created,
    }
}
