﻿#region 命名空间
using Microsoft.Xna.Framework.Content.Pipeline;
#endregion

namespace MonoGameContentBuild
{
    /// <summary>
    /// 提供自定义方法来报告内容导入程序或处理程序中的消息或警告。
    /// </summary>
    public class CustomContentBuildLogger : ContentBuildLogger
    {
        #region 方法

        #region 实现 ContentBuildLogger

        /// <summary>
        /// 从内容导入程序或处理程序输出高优先级状态消息。
        /// </summary>
        public override void LogImportantMessage(string message, params object[] messageArgs)
        {
        }

        /// <summary>
        /// 从内容导入程序或处理程序输出低优先级状态消息。
        /// </summary>
        public override void LogMessage(string message, params object[] messageArgs)
        {
        }

        /// <summary>
        /// 从内容导入程序或处理程序输出警告消息。
        /// </summary>
        public override void LogWarning(string helpLink, ContentIdentity contentIdentity, string message, params object[] messageArgs)
        {
        }

        #endregion

        #endregion
    }
}
