﻿#region 命名空间
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework.Content;
#endregion

namespace TestGame
{
    [Serializable]
    public class HeroData
    {
        public string Name { get; set; }
        public int Health { get; set; }
        public float Speed { get; set; }
        public float Power { get; set; }
        public float Magic { get; set; }
        public List<WeaponData> Weapons { get; set; }
        public List<SpriteData> Sprites { get; set; }
    }

    public class WeaponData
    {
        public string Name { get; set; }
        public float Attack { get; set; }
        public float Defense { get; set; }
    }

    public class SpriteData
    {
        public string Name { get; set; }
        public float Speed { get; set; }
        public float Magic { get; set; }
    }
}
